// Overlay js - lightweight jquery overlay plugin - http://codinglog.com/jquery/overlay-js/
// Copyright (c) 2011 Sandeep MT - http://mtsandeep.com
// Licensed under the MIT license: http://www.opensource.org/licenses/mit-license.php
(function($){ 
	$.fn.extend({  
		overlay: function(options) {

			var defaults = { 
				position: 'fixed',
				background: '#000',
				opacity:0.5,
				url: '',
				showAfter: 0,
				hideAfter: 0,
				close: true,
				escClose: true,
				remove: false
			};
			  
			var options = $.extend(defaults, options); 
		  
			return this.each(function() { 
				var o = options; 
				  
				var $this = $(this); // div with the content of overlay
				
				var pageCover = '<div id="page-cover" style="position:fixed;top:0;left:0;width:100%;height:100%;background-color:'+o.background+';zoom:1;filter:alpha(opacity='+o.opacity*100+');opacity:'+o.opacity+';z-index:99;"></div>';
				var close ='<a class="overlay-close" href="#">close</a>';
				var loading = 'loading...'; //we can use an image if needed
				
				if(o.showAfter){
					setTimeout(function() {
						showOverlay();
					  }, o.showAfter);
				} else {
					showOverlay();
				}
				
				if(o.hideAfter){
					 setTimeout(function() {
						removeOverlay();
					  }, o.showAfter+o.hideAfter);
				} else if(o.remove){
					removeOverlay();
				}
				
				if(o.escClose) {
					$(document).bind('keyup', function(e){
					   if (e.which == 27) {
						  removeOverlay();
						  $(document).unbind('keyup');
					   }
					});
				}
				
				$('.overlay-close').live('click', function(e) {
					e.preventDefault();
					removeOverlay();
				});
				
				$(window).bind('resize', function(){  
					fixMessage();  
				}); 
				
				function showOverlay(){
					if ($('#page-cover').length > 0){
						$('#page-cover').css('background-color',o.background).css('opacity',o.opacity).css('filter','alpha(opacity ='+o.opacity*100+')').show(); //adding new background and opacity if it already exists
					} else {
						$('body').append(pageCover);
					}
					
					$this.css('z-index',101).addClass('overlay').show(); //show the div
					loadContent();
				}
				
				function showClose(){
					if(o.close){
						if ($this.children('.overlay-close').length){
							$this.children('.overlay-close').show();
						} else {
							$this.prepend(close);
						}
					}
				}
				
				function loadContent(){
					if(o.url){ //check if url is provided, if yes load that to the div
						$this.html(loading);
						$this.load(o.url, function() {
							fixMessage();
							showClose();
						});
					} else {
						fixMessage();
						showClose();
					}
				}
				
				function fixMessage(){
					var remainingHeight = $(window).height() - $this.outerHeight();
					if(remainingHeight < 40){
						$this.css('position','absolute').css('top', $(window).scrollTop()+20+'px');
					} else if(o.position=='fixed'){
						$this.css('position',o.position).css('top', remainingHeight / 2 + 'px');
					} else {
						$this.css('position',o.position).css('top', (remainingHeight / 2) + $(window).scrollTop() + 'px');
					}
					$this.css('left', (($(window).width() - $this.outerWidth()) / 2) + $(window).scrollLeft() + 'px');
				}
				
				function removeOverlay(){
					$('#page-cover').hide();
					$this.children('.overlay-close').hide();
					$this.removeAttr('style').removeClass('overlay');
					$(window).unbind('resize');
					if(o.url){
						$this.empty();
					}
				}
			
			}); 
		} 
	}); 
})(jQuery); 